#version 150

#moj_import <light.glsl>
#moj_import <fog.glsl>

in vec3 Position;
in vec2 UV0;
in vec4 Color;
in ivec2 UV2;

uniform sampler2D Sampler0;
uniform sampler2D Sampler2;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform int FogShape;
uniform vec4 FogColor;

out float vertexDistance;
out vec2 texCoord0;
out vec2 texCoord2;
out vec4 vertexColor;
out float isRain;
out mat4 passModelViewMat;
out mat4 passProjMat;

void main() {
    gl_Position = ProjMat * ModelViewMat * vec4(Position, 1.0);

    vertexDistance = fog_distance(ModelViewMat, Position, FogShape);
    texCoord0 = UV0;

    isRain = 0;
    if (ProjMat[3][2] == -2.0) {
        vertexColor = Color;
    } else {
        vertexColor = Color * minecraft_sample_lightmap(Sampler2, UV2, FogColor);
        if (ivec4(texture(Sampler0, UV0 + vec2(-0.1, -0.1) / textureSize(Sampler0, 0)) * 255.0 + 0.5) == ivec4(0, 254, 254, 1)) {
            isRain = 1.0;
            if (textureSize(Sampler0, 0) == ivec2(64, 256)) {
                texCoord0.xy -= texCoord0.yx * vec2(1.0, -0.1);
            }
        }
    }

    passModelViewMat = ModelViewMat;
    passProjMat = ProjMat;
}
