#version 150

in vec3 Position;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;

out float vertexDistance;
out vec4 rawPos;

void main() {
    if (ProjMat[3][2] != -2.0) {
        vec4 pos = ProjMat * vec4(Position, 1.0);
        pos.y = -pos.z;
        gl_Position = pos;
        rawPos = vec4(Position, 1.0);
    } else {
        gl_Position = ProjMat * ModelViewMat * vec4(Position, 1.0);
    }

    vertexDistance = length((ModelViewMat * vec4(Position, 1.0)).xyz);
}
