#version 150

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;

in vec2 texCoord0;

out vec4 fragColor;

flat in int isSky;
in vec3 skyPos;

void main() {
    if (isSky == 1) {
        fragColor = vec4(skyPos, 1.0);
    } else {
        vec4 color = texture(Sampler0, texCoord0);
        if (color.a == 0.0) {
            discard;
        }
        fragColor = color * ColorModulator;
    }
}
