#version 150

in vec3 Position;
in vec2 UV0;

uniform sampler2D Sampler0;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform mat3 IViewRotMat;

out vec2 texCoord0;

flat out int isSky;
out vec3 skyPos;

void main() {
    gl_Position = ProjMat * ModelViewMat * vec4(Position, 1.0);

    texCoord0 = UV0;

    isSky = 0;
    skyPos = vec3(0.0);
    if (textureSize(Sampler0, 0) == ivec2(128, 64) && int(texture(Sampler0, texCoord0).a * 255.0 + 0.5) == 167) {
        //isSky = 1;
        switch (gl_VertexID % 4) {
            case 0:
                //gl_Position = vec4(-1.0, -1.0, 1.0, 1.0);
                break;
            case 1:
                //gl_Position = vec4(1.0, -1.0, 1.0, 1.0);
                break;
            case 2:
                //gl_Position = vec4(1.0, 1.0, 1.0, 1.0);
                break;
            case 3:
                //gl_Position = vec4(-1.0, 1.0, 1.0, 1.0);
                break;
        }
        vec4 pos = inverse(ProjMat) * gl_Position;
        skyPos = normalize(IViewRotMat * pos.xyz);
    }
}
