#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in vec2 texCoord0;
in float vertexDistance;
in vec4 vertexColor;
in vec4 normal;
in vec3 vertexPos;

out vec4 fragColor;

vec4 applyFog(vec4 color, float cloudDistance) {
    return linear_fog(color, cloudDistance, FogStart, FogEnd, FogColor * vec4(1.0, 1.0, 1.0, 0.0));
}

void main() {
    vec3 pos = vertexPos;
    vec4 color = vec4(0.0);
    for (float i = 0.0; i < 2.0; i+=1.0) {
        vec2 uv = texCoord0 / (1.0 + i * i * 4.0);
        uv += vertexPos.xz / vertexPos.y * 0.01 * i + 0.25 * i;
        vec4 layer = applyFog(texture(Sampler0, mod(uv, 1.0)) * vertexColor * ColorModulator, length(pos.xz) + i * 128.0);
        color = vec4(mix(layer.rgb, color.rgb, color.a), color.a + layer.a);
    }
    if (color.a < 0.1) {
        discard;
    }
    fragColor = color;
}
