#version 150

#moj_import <fog.glsl>

in vec3 Position;
in vec2 UV0;
in vec4 Color;
in vec3 Normal;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform mat3 IViewRotMat;
uniform vec4 FogColor;

out vec2 texCoord0;
out float vertexDistance;
out vec4 vertexColor;
out vec4 normal;
out vec3 vertexPos;

void main() {
    vec4 pos = ModelViewMat * vec4(Position, 1.0);
    vec3 pos3 = IViewRotMat * pos.xyz;
    pos3.y -= Normal.y * 2.0;
    pos.xyz = pos3 * IViewRotMat;
    gl_Position = ProjMat * pos;

    if (Normal.y > -0.4) {
        gl_Position = vec4(0.0, 0.0, 0.0, 1.0);
    }

    texCoord0 = UV0;
    vertexColor = mix(FogColor, vec4(1.0, 1.0, 1.0, 0.01), 0.2);
    normal = ProjMat * ModelViewMat * vec4(Normal, 0.0);
    vertexPos = pos3;
}
