#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;

out vec4 fragColor;

void main() {
    vec4 color = vec4(0.0);
    if (texCoord0 == clamp(texCoord0, 0.0, 1.0)) {
        vec2 shadowCoord = abs(texCoord0 * 2.0 - 1.0);
        float shadowFade = max(shadowCoord.x, shadowCoord.y);
        shadowFade = 1.0 - pow(shadowFade, 4.0);
        shadowFade = floor(shadowFade * 4.0 + 0.5) / 4.0;
        color = vec4(0.0, 0.0, 0.0, shadowFade);
    }
    color *= vertexColor * ColorModulator;
    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
}
