#version 150

#moj_import <light.glsl>
#moj_import <fog.glsl>

in vec3 Position;
in vec4 Color;
in vec2 UV0;
in ivec2 UV2;

uniform sampler2D Sampler0;
uniform sampler2D Sampler2;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform mat3 IViewRotMat;
uniform int FogShape;
uniform vec4 FogColor;

out float vertexDistance;
out vec4 vertexColor;
out vec2 texCoord0;

void main() {
    vec3 pos = Position;

    if (ProjMat[3][2] == -2.0) {
        vertexColor = Color;
        if (int(pos.z + 0.5) == 400 && pos.z < 400.01) {
            pos.x -= 1.0;
            vertexColor.rgb *= 2.0;
        }
        } else {
            vertexColor = Color * minecraft_sample_lightmap(Sampler2, UV2, FogColor);
        }
        texCoord0 = UV0;

        gl_Position = ProjMat * ModelViewMat * vec4(pos, 1.0);

        vertexDistance = fog_distance(ModelViewMat, IViewRotMat * pos, FogShape);
    }
