#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec4 vertexLight;
in vec2 texCoord0;
in vec4 normal;
in float material;
in float wave;
in float fade;
in float sky;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0);
    float shine = clamp((length(color.rgb) - 1.3) * max(0.0, normal.y), 0.0, 1.0) * clamp(1.0 - vertexDistance / 64.0, 0.0, 1.0) * pow(sky, 8.0) * pow(vertexLight.r, 0.3) * 0.5;
    int mat = int(material + 0.5);
    color *= vertexColor * vertexLight;
    if (mat == 1) {
        color.rgb *= mix(vec3(0.6, 0.8, 0.5), vec3(1.0, 1.2, 1.5), vertexColor.r);
        color.rgb = mix(color.rgb * (1.0 + wave * 0.1 + 0.2), color.rgb, clamp(vertexDistance / 80.0, 0.0, 0.8));
        color.rgb = mix(color.rgb, normalize(FogColor.rgb) * 4.0, shine);
        color.a = clamp(1.0 - pow(1.0 - clamp(vertexDistance / 16.0, 0.0, 1.0), 2.0), 0.0, 1.0) * 0.5 + 0.4;
    }
    else if (mat == 2) {
        color = texture(Sampler0, texCoord0);
        color = vec4(color.rgb * vec3(1.5 - fade * 0.75, fade, fade * 0.6 + 0.8) - max(0.0, 0.2 - fade), max(0.0, color.b - pow(fade, 0.5)) * 0.64);
        if (color.a < 0.05) {
            discard;
        }
    }
    fragColor = linear_fog(color * ColorModulator, vertexDistance, FogStart, FogEnd, FogColor);
}
