#version 150

uniform sampler2D DiffuseSampler;

uniform vec4 ColorModulate;

in vec2 texCoord;

out vec4 fragColor;

void main(){
    vec2 oneTex = 1.0 / textureSize(DiffuseSampler, 0);
    vec4 color = texture(DiffuseSampler, texCoord);

    vec3 blurredColor = vec3(0.0);
    float totalColor = 0.0;
    for (float i = -1.0; i < 1.0; i += 0.1) {
        for (float j = -1.0; j < 1.0; j += 0.1) {
            if (length(vec2(i, j)) < 1.0) {
                vec2 uv = texCoord + vec2(i, j) * oneTex * 8.0;
                blurredColor += texture(DiffuseSampler, uv).rgb;
                totalColor += 1.0;
            }
        }
    }
    blurredColor /= totalColor;

    color.rgb = blurredColor;

    fragColor = color * ColorModulate;
}
