#version 150

uniform sampler2D DiffuseSampler;

uniform vec2 OutSize;
uniform vec4 ColorModulate;

in vec2 texCoord;

out vec4 fragColor;

void main(){
    vec2 oneTex = 1.0 / OutSize;
    vec3 color = vec3(0.0);

    for (float i = -1.0; i < 1.0; i += 0.08) {
        for (float j = -1.0; j < 1.0; j += 0.1) {
            vec2 uv = texCoord + vec2(i, j) * oneTex * 32.0;
            color += max(vec3(0.0), texture(DiffuseSampler, uv).rgb - 0.6) * max(0.0, pow(1.0 - length(vec2(i, j)), 1.5)) * 0.1;
        }
    }

    color = mix(color, vec3(length(color) / 2.5), min(length(color) * 0.5, 0.6));

    fragColor = vec4(color, 1.0) * ColorModulate;
}
